use askama::Template;
use axum::response::{Html,Response};
use axum::{
	http::StatusCode,
	response::IntoResponse,
};

pub struct HtmlTemplate<T>(pub T);

impl<T> IntoResponse for HtmlTemplate<T>
where
	T: Template,
{
	fn into_response(self) -> Response {
		match self.0.render() {
			Ok(html) => Html(html).into_response(),
			Err(err) => (StatusCode::INTERNAL_SERVER_ERROR, format!("Failed to render html template: {err}")).into_response(),
		}
	}
}
